/**************************************************************************

	nSuspend

	main.c

	(C) Copyright 2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <tchar.h>
#include <aygshell.h>

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define MAIN_WND_CLASS			TEXT("nSusWndCls")

#define BUF_SIZE				256

#define WM_ENDAPP				(WM_USER + 100)
#define WM_TRAY_NOTIFY			(WM_USER + 101)
#define TRAY_ID					1
#define ID_CLOCK_TIMER			1
#define TIMER_INTERVAL			10000

#define ID_MENUITEM_SET			40001
#define ID_MENUITEM_SUSPEND		40002
#define ID_MENUITEM_QUIT		40003

#define TYPE_TIME				0
#define TYPE_WAIT				1


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE hInst;

static int type = TYPE_TIME;
static int time_h = 0;
static int time_m = 0;
static int wait_h = 0;
static int wait_m = 0;

static int wait_cnt = 0;
static BOOL ShowDlg;
static BOOL cmd_flag;


/******************************************************************************

	TrayMessage

	^XNgC̃ACR̐ݒ

******************************************************************************/

static BOOL TrayMessage(HWND hWnd, DWORD dwMessage, UINT uID, HICON hIcon, TCHAR *pszTip)
{
	NOTIFYICONDATA tnd;

	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = hWnd;
	tnd.uID	= uID;
	tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage = WM_TRAY_NOTIFY;
	tnd.hIcon = hIcon;
	lstrcpy(tnd.szTip, (pszTip == NULL) ? TEXT("") : pszTip);
	return Shell_NotifyIcon(dwMessage, &tnd);
}


/******************************************************************************

	ShowPopupMenu

	j[\

******************************************************************************/

static void ShowPopupMenu(HWND hWnd)
{
	HMENU hMenu;
	RECT WndRect;

	hMenu = CreatePopupMenu();
	if(hMenu == NULL){
		return;
	}
	//j[ɍڂǉ
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_SET, TEXT("&Set"));
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_SUSPEND, TEXT("Sus&pend"));
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_QUIT, TEXT("&Exit application"));

	SetForegroundWindow(hWnd);
	GetWindowRect(hWnd, &WndRect);
	//j[\
	TrackPopupMenu(hMenu, TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
		WndRect.right, WndRect.bottom, 0, hWnd, NULL);
	DestroyMenu(hMenu);
	PostMessage(hWnd, WM_NULL, 0, 0);
}


/******************************************************************************

	Suspend

	TXyh

******************************************************************************/

static void Suspend()
{
	keybd_event(VK_OFF, 0, 0, 0); // down
	keybd_event(VK_OFF, 0, KEYEVENTF_KEYUP, 0); // up
}


/******************************************************************************

	TimeCheck

	Ԃ̃`FbN

******************************************************************************/

static BOOL TimeCheck(BOOL init)
{
	SYSTEMTIME sys_time;
	static int min;

	//[J^C擾
	GetLocalTime(&sys_time);

	if(init == TRUE){
		//
		min = sys_time.wMinute;
		return FALSE;
	}

	switch(type)
	{
	case TYPE_TIME:
		if(time_h == sys_time.wHour && time_m == sys_time.wMinute){
			return TRUE;
		}
		break;

	case TYPE_WAIT:
		if(min != sys_time.wMinute){
			min = sys_time.wMinute;
			wait_cnt--;
		}
		if(wait_cnt <= 0){
			return TRUE;
		}
		break;
	}
	return FALSE;
}


/******************************************************************************

	OptionDlgProc

	ݒ

******************************************************************************/

static BOOL CALLBACK SetDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	BOOL enable;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);

		SetWindowText(hDlg, TEXT("Set"));

		//Rg[̏
		if(type == TYPE_TIME){
			SendDlgItemMessage(hDlg, IDC_RADIO_TIME, BM_SETCHECK, 1, 0);
		}else{
			SendDlgItemMessage(hDlg, IDC_RADIO_WAIT, BM_SETCHECK, 1, 0);
			wait_h = wait_cnt / 60;
			wait_m = wait_cnt % 60;
		}
		SetDlgItemInt(hDlg, IDC_EDIT_TIME_H, time_h, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_TIME_MIN, time_m, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WAIT_H, wait_h, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WAIT_MIN, wait_m, FALSE);

		SendMessage(hDlg, WM_COMMAND, IDC_RADIO_TIME, 0);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_EDIT_TIME_H:
		case IDC_EDIT_TIME_MIN:
		case IDC_EDIT_WAIT_H:
		case IDC_EDIT_WAIT_MIN:
			switch(HIWORD(wParam))
			{
			case EN_SETFOCUS:
				SHSipPreference(hDlg, SIP_UP);
				break;
			case EN_KILLFOCUS:
				SHSipPreference(hDlg, SIP_DOWN);
				break;
			}
			break;

		case IDC_RADIO_TIME:
		case IDC_RADIO_WAIT:
			enable = (SendDlgItemMessage(hDlg, IDC_RADIO_TIME, BM_GETCHECK, 0, 0) == 1) ? TRUE : FALSE;
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_TIME_H), enable);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_TIME_MIN), enable);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_WAIT_H), !enable);
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_WAIT_MIN), !enable);
			break;

		case IDOK:
			//ݒ̎擾
			if(SendDlgItemMessage(hDlg, IDC_RADIO_TIME, BM_GETCHECK, 0, 0) == 1){
				type = 0;
			}else if(SendDlgItemMessage(hDlg, IDC_RADIO_WAIT, BM_GETCHECK, 0, 0) == 1){
				type = 1;
			}
			time_h = GetDlgItemInt(hDlg, IDC_EDIT_TIME_H, NULL, FALSE);
			time_m = GetDlgItemInt(hDlg, IDC_EDIT_TIME_MIN, NULL, FALSE);
			wait_h = GetDlgItemInt(hDlg, IDC_EDIT_WAIT_H, NULL, FALSE);
			wait_m = GetDlgItemInt(hDlg, IDC_EDIT_WAIT_MIN, NULL, FALSE);
			wait_cnt = wait_h * 60 + wait_m;

			SHSipPreference(hDlg, SIP_DOWN);
			EndDialog(hDlg, TRUE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	MainProc

	MainvV[W

******************************************************************************/

static LRESULT CALLBACK MainProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HICON hIcon;

	switch(msg)
	{
	case WM_CREATE:
		//^XNgCɃACRݒ肷
		hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, 0);
		TrayMessage(hWnd, NIM_ADD, TRAY_ID, hIcon, TEXT("nSuspend"));

		//ݒ
		ShowDlg = TRUE;
		if(cmd_flag == FALSE){
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SET), hWnd, SetDlgProc, 0);
		}

		//^C}[
		TimeCheck(TRUE);
		SendMessage(hWnd, WM_TIMER, ID_CLOCK_TIMER, 0);
		SetTimer(hWnd, ID_CLOCK_TIMER, TIMER_INTERVAL, NULL);
		ShowDlg = FALSE;
		break;

	case WM_HIBERNATE:
	case WM_ENDAPP:
		//^XNgC̃ACR폜
		TrayMessage(hWnd, NIM_DELETE, TRAY_ID, NULL, TEXT(""));
		DestroyWindow(hWnd);
		break;

	case WM_CLOSE:
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_TIMER:
		switch(wParam)
		{
		case ID_CLOCK_TIMER:
			if(TimeCheck(FALSE) == TRUE){
				KillTimer(hWnd, ID_CLOCK_TIMER);
				Suspend();
				SendMessage(hWnd, WM_ENDAPP, 0, 0);
			}
			break;
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case ID_MENUITEM_SET:
			if(ShowDlg == TRUE){
				break;
			}
			ShowDlg = TRUE;

			KillTimer(hWnd, ID_CLOCK_TIMER);
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SET), hWnd, SetDlgProc, 0);
			TimeCheck(TRUE);

			//^C}[
			SendMessage(hWnd, WM_TIMER, ID_CLOCK_TIMER, 0);
			SetTimer(hWnd, ID_CLOCK_TIMER, TIMER_INTERVAL, NULL);
			ShowDlg = FALSE;
			break;

		case ID_MENUITEM_SUSPEND:
			Suspend();
		case ID_MENUITEM_QUIT:
			SendMessage(hWnd, WM_ENDAPP, 0, 0);
			break;
		}
		break;

	case WM_TRAY_NOTIFY:
		switch(lParam)
		{
		case WM_LBUTTONUP:
			ShowPopupMenu(hWnd);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitApplication

	EBhE̍쐬

******************************************************************************/

static HWND InitApplication(HANDLE hInstance)
{
	WNDCLASS  wc;

	//EBhENXo^
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)MainProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = NULL;
	wc.hCursor = NULL;
	wc.hbrBackground = NULL;
	wc.lpszMenuName =  NULL;
	wc.lpszClassName = MAIN_WND_CLASS;
	RegisterClass(&wc);

	//EBhE쐬
	return CreateWindow(MAIN_WND_CLASS, TEXT(""), WS_OVERLAPPED,
		0, 0, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int CmdShow)
{
	MSG msg;
	TCHAR *p, *r;
	TCHAR tmp[BUF_SIZE];

	hInst = hInstance;

	//ɋNĂꍇ͏I
	if(FindWindow(MAIN_WND_CLASS, NULL) != NULL){
		return 0;
	}

	//R}hC̓WJ
	p = lpCmdLine;
	if(*p == TEXT('/')){
		cmd_flag = TRUE;

		p++;
		if(*p == TEXT('T') || *p == TEXT('t')){
			type = TYPE_TIME;
		}else if(*p == TEXT('W') || *p == TEXT('w')){
			type = TYPE_WAIT;
		}

		//
		if(*p != TEXT('\0')){
			for(p++; *p == TEXT(' '); p++);
			for(r = tmp; *p != TEXT('\0') && *p != TEXT(':') && *p != TEXT(' '); p++, r++){
				*r = *p;
			}
			*r = TEXT('\0');
			if(type == TYPE_TIME){
				time_h = _ttol(tmp);
			}else if(type == TYPE_WAIT){
				wait_h = _ttol(tmp);
			}
		}

		//
		if(*p != TEXT('\0')){
			for(p++; *p == TEXT(' ') || *p == TEXT(':'); p++);
			for(r = tmp; *p != TEXT('\0') && *p != TEXT(':') && *p != TEXT(' '); p++, r++){
				*r = *p;
			}
			*r = TEXT('\0');
			if(type == TYPE_TIME){
				time_m = _ttol(tmp);
			}else if(type == TYPE_WAIT){
				wait_m = _ttol(tmp);
			}
		}

		if(type == TYPE_WAIT){
			wait_cnt = wait_h * 60 + wait_m;
		}
	}

	//EBhE̍쐬
	if(InitApplication(hInstance) == NULL){
		return 0;
	}

	//bZ[W[v
	while(GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}
/* End of source */
